using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.Data.OleDb;
using Pervasive.Data.SqlClient;


namespace PSQL.NET_Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cboType.Items.Add("ODBC");
            cboType.Items.Add("OLEDB");
            cboType.Items.Add("Pervasive Data Provider for .NET");
            cboType.Items.Add("Btrieve Classes for .NET");
            cboType.SelectedIndex = 0;
            txtConnStr.Text = "DSN=DEMODATA";
        }

        private void cboType_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cboType.SelectedIndex)
            {    
                case 0:
                    txtConnStr.Text = "DSN=DEMODATA";
                    label3.Text = "SQL:";
                    break;
                case 1:
                    txtConnStr.Text = "Provider=PervasiveOLEDB;Data Source=Demodata;Location=localhost";
                    label3.Text = "SQL:";
                    break;
                case 2:
                    txtConnStr.Text = "ServerDSN=Demodata;ServerName=localhost";
                    label3.Text = "SQL:";
                    break;
                case 3:
                    txtConnStr.Text = "btrv://localhost/Demodata?prompt=no";
                    label3.Text = "TableName:";
                    break;
            }
        }
        static BtLib.Ddf d;
        private void cmdExecute_Click(object sender, EventArgs e)
        {
            switch (cboType.SelectedIndex)
            {
                case 0:
                    try
                    {
                        OdbcConnection odbcConn = new OdbcConnection(txtConnStr.Text);
                        odbcConn.Open();
                        OdbcDataAdapter da = new OdbcDataAdapter(rtSQL.Text, odbcConn);
                        DataSet ds = new DataSet();
                        da.Fill(ds, "table1");
                        this.dataGridView1.DataSource = ds;
                        this.dataGridView1.DataMember = "table1";
                        odbcConn.Close();
                        odbcConn.Dispose();
                        odbcConn = null;
                    }
                    catch (Exception ex)
                    { MessageBox.Show(ex.Message); }
                    break;
                case 1:
                    try
                    {
                        OleDbConnection oledbConn = new OleDbConnection(txtConnStr.Text);
                        oledbConn.Open();
                        OleDbDataAdapter da = new OleDbDataAdapter(rtSQL.Text, oledbConn);
                        DataSet ds = new DataSet();
                        da.Fill(ds, "table1");
                        this.dataGridView1.DataSource = ds;
                        this.dataGridView1.DataMember = "table1";
                        oledbConn.Close();
                        oledbConn.Dispose();
                        oledbConn = null;
                     }
                    catch (Exception ex)
                    { MessageBox.Show(ex.Message); }
                    break;
                case 2:
                    try
                    {
                        PsqlConnection psqlConn = new PsqlConnection(txtConnStr.Text);
                        psqlConn.Open();
                        PsqlDataAdapter da = new PsqlDataAdapter(rtSQL.Text, psqlConn);
				        DataSet ds=new DataSet();
				        da.Fill(ds,"table1");
				        this.dataGridView1.DataSource=ds;
				        this.dataGridView1.DataMember="table1";
                        psqlConn.Close();
                        psqlConn.Dispose();
                        psqlConn = null;
                    }
                    catch (Exception ex)
                        { MessageBox.Show(ex.Message); }			    
                    break; 

       case 3:
                    try
                    {
                        d = new BtLib.Ddf(txtConnStr.Text);
                    }
                    catch (System.Exception ex)
                        {
                        MessageBox.Show(ex.ToString());
                        break;
                        }			    
                    

                    try
                    {
                        BtLib.Record r = d.GetRecord(rtSQL.Text);
                        r.Open();
                        DataSet ds = r.GetDataSet();

                        this.dataGridView1.DataSource = ds;
                        this.dataGridView1.DataMember = rtSQL.Text;
                        r.Close();
                        d.LogOut();
                    }
                    catch (System.Exception ex)
                    { 
                        MessageBox.Show(ex.ToString());
                        d.LogOut();
                    }
                    break; 

            }
            MessageBox.Show("Done");
            
        }
    }
}